Index: uspace/srv/net/tl/icmp/icmp.c
===================================================================
--- uspace/srv/net/tl/icmp/icmp.c	(revision b5cbff48576a057d15deb2e28751ec635d099719)
+++ uspace/srv/net/tl/icmp/icmp.c	(revision 936835e135a18adfccf27258eb51edd1dd5fe962)
@@ -659,91 +678,102 @@
 	 *  - Answer the first NET_ICMP_INIT call.
 	 */
-	ipc_answer_0( callid, EOK );
-
-//	fibril_rwlock_initialize( & lock );
-
-	echo_data = ( icmp_echo_ref ) malloc( sizeof( * echo_data ));
-	if( ! echo_data ) return ENOMEM;
+	res = EOK;
+	answer_count = 0;
+
+//	fibril_rwlock_initialize(&lock);
+
+	echo_data = (icmp_echo_ref) malloc(sizeof(*echo_data));
+	if(! echo_data){
+		return ENOMEM;
+	}
+
 	// assign a new identifier
-	fibril_rwlock_write_lock( & icmp_globals.lock );
-	ERROR_CODE = icmp_bind_free_id( echo_data );
-	fibril_rwlock_write_unlock( & icmp_globals.lock );
-	if( ERROR_CODE < 0 ){
-		free( echo_data );
-		return ERROR_CODE;
-	}
-
-	while( keep_on_going ){
-		refresh_answer( & answer, & answer_count );
-
-		callid = async_get_call( & call );
-
-		switch( IPC_GET_METHOD( call )){
+	fibril_rwlock_write_lock(&icmp_globals.lock);
+	res = icmp_bind_free_id(echo_data);
+	fibril_rwlock_write_unlock(&icmp_globals.lock);
+	if(res < 0){
+		free(echo_data);
+		return res;
+	}
+
+	while(keep_on_going){
+
+		// answer the call
+		answer_call(callid, res, &answer, answer_count);
+
+		// refresh data
+		refresh_answer(&answer, &answer_count);
+
+		// get the next call
+		callid = async_get_call(&call);
+
+		// process the call
+		switch(IPC_GET_METHOD(call)){
 			case IPC_M_PHONE_HUNGUP:
 				keep_on_going = false;
-				ERROR_CODE = EOK;
+				res = EHANGUP;
 				break;
 			case NET_ICMP_ECHO:
-//				fibril_rwlock_write_lock( & lock );
-				if( ! async_data_write_receive( & data_callid, & length )){
-					ERROR_CODE = EINVAL;
+//				fibril_rwlock_write_lock(&lock);
+				if(! async_data_write_receive(&data_callid, &length)){
+					res = EINVAL;
 				}else{
-					addr = malloc( length );
-					if( ! addr ){
-						ERROR_CODE = ENOMEM;
+					addr = malloc(length);
+					if(! addr){
+						res = ENOMEM;
 					}else{
-						if( ! ERROR_OCCURRED( async_data_write_finalize( data_callid, addr, length ))){
-							fibril_rwlock_write_lock( & icmp_globals.lock );
-							ERROR_CODE = icmp_echo( echo_data->identifier, echo_data->sequence_number, ICMP_GET_SIZE( call ), ICMP_GET_TIMEOUT( call ), ICMP_GET_TTL( call ), ICMP_GET_TOS( call ), ICMP_GET_DONT_FRAGMENT( call ), addr, ( socklen_t ) length );
-							fibril_rwlock_write_unlock( & icmp_globals.lock );
-							free( addr );
-							if( echo_data->sequence_number < MAX_UINT16 ){
+						if(! ERROR_OCCURRED(async_data_write_finalize(data_callid, addr, length))){
+							fibril_rwlock_write_lock(&icmp_globals.lock);
+							res = icmp_echo(echo_data->identifier, echo_data->sequence_number, ICMP_GET_SIZE(call), ICMP_GET_TIMEOUT(call), ICMP_GET_TTL(call), ICMP_GET_TOS(call), ICMP_GET_DONT_FRAGMENT(call), addr, (socklen_t) length);
+							fibril_rwlock_write_unlock(&icmp_globals.lock);
+							free(addr);
+							if(echo_data->sequence_number < MAX_UINT16){
 								++ echo_data->sequence_number;
 							}else{
 								echo_data->sequence_number = 0;
 							}
+						}else{
+							res = ERROR_CODE;
 						}
 					}
 				}
-//				fibril_rwlock_write_unlock( & lock );
+//				fibril_rwlock_write_unlock(&lock);
 				break;
 			default:
-				ERROR_CODE = icmp_process_message( & call );
+				res = icmp_process_message(&call);
 		}
-
-		answer_call( callid, ERROR_CODE, & answer, answer_count );
 	}
 
 	// release the identifier
-	fibril_rwlock_write_lock( & icmp_globals.lock );
-	icmp_echo_data_exclude( & icmp_globals.echo_data, echo_data->identifier );
-	fibril_rwlock_write_unlock( & icmp_globals.lock );
-	return EOK;
-}
-
-int icmp_process_message( ipc_call_t * call ){
+	fibril_rwlock_write_lock(&icmp_globals.lock);
+	icmp_echo_data_exclude(&icmp_globals.echo_data, echo_data->identifier);
+	fibril_rwlock_write_unlock(&icmp_globals.lock);
+	return res;
+}
+
+int icmp_process_message(ipc_call_t * call){
 	ERROR_DECLARE;
 
-	packet_t	packet;
-
-	switch( IPC_GET_METHOD( * call )){
+	packet_t packet;
+
+	switch(IPC_GET_METHOD(*call)){
 		case NET_ICMP_DEST_UNREACH:
-			if( ! ERROR_OCCURRED( packet_translate( icmp_globals.net_phone, & packet, IPC_GET_PACKET( call )))){
-				ERROR_CODE = icmp_destination_unreachable_msg( 0, ICMP_GET_CODE( call ), ICMP_GET_MTU( call ), packet );
+			if(! ERROR_OCCURRED(packet_translate(icmp_globals.net_phone, &packet, IPC_GET_PACKET(call)))){
+				ERROR_CODE = icmp_destination_unreachable_msg(0, ICMP_GET_CODE(call), ICMP_GET_MTU(call), packet);
 			}
 			return ERROR_CODE;
 		case NET_ICMP_SOURCE_QUENCH:
-			if( ! ERROR_OCCURRED( packet_translate( icmp_globals.net_phone, & packet, IPC_GET_PACKET( call )))){
-				ERROR_CODE = icmp_source_quench_msg( 0, packet );
+			if(! ERROR_OCCURRED(packet_translate(icmp_globals.net_phone, &packet, IPC_GET_PACKET(call)))){
+				ERROR_CODE = icmp_source_quench_msg(0, packet);
 			}
 			return ERROR_CODE;
 		case NET_ICMP_TIME_EXCEEDED:
-			if( ! ERROR_OCCURRED( packet_translate( icmp_globals.net_phone, & packet, IPC_GET_PACKET( call )))){
-				ERROR_CODE = icmp_time_exceeded_msg( 0, ICMP_GET_CODE( call ), packet );
+			if(! ERROR_OCCURRED(packet_translate(icmp_globals.net_phone, &packet, IPC_GET_PACKET(call)))){
+				ERROR_CODE = icmp_time_exceeded_msg(0, ICMP_GET_CODE(call), packet);
 			}
 			return ERROR_CODE;
 		case NET_ICMP_PARAMETERPROB:
-			if( ! ERROR_OCCURRED( packet_translate( icmp_globals.net_phone, & packet, IPC_GET_PACKET( call )))){
-				ERROR_CODE = icmp_parameter_problem_msg( 0, ICMP_GET_CODE( call ), ICMP_GET_POINTER( call ), packet );
+			if(! ERROR_OCCURRED(packet_translate(icmp_globals.net_phone, &packet, IPC_GET_PACKET(call)))){
+				ERROR_CODE = icmp_parameter_problem_msg(0, ICMP_GET_CODE(call), ICMP_GET_POINTER(call), packet);
 			}
 			return ERROR_CODE;
@@ -753,13 +783,15 @@
 }
 
-int	icmp_release_and_return( packet_t packet, int result ){
-	pq_release( icmp_globals.net_phone, packet_get_id( packet ));
+int icmp_release_and_return(packet_t packet, int result){
+	pq_release(icmp_globals.net_phone, packet_get_id(packet));
 	return result;
 }
 
-int icmp_bind_free_id( icmp_echo_ref echo_data ){
-	icmp_param_t	index;
-
-	if( ! echo_data ) return EBADMEM;
+int icmp_bind_free_id(icmp_echo_ref echo_data){
+	icmp_param_t index;
+
+	if(! echo_data){
+		return EBADMEM;
+	}
 	// from the last used one
 	index = icmp_globals.last_used_id;
@@ -767,5 +799,5 @@
 		++ index;
 		// til the range end
-		if( index >= ICMP_FREE_IDS_END ){
+		if(index >= ICMP_FREE_IDS_END){
 			// start from the range beginning
 			index = ICMP_FREE_IDS_START - 1;
@@ -773,16 +805,16 @@
 				++ index;
 				// til the last used one
-				if( index >= icmp_globals.last_used_id ){
+				if(index >= icmp_globals.last_used_id){
 					// none found
 					return ENOTCONN;
 				}
-			}while( icmp_echo_data_find( & icmp_globals.echo_data, index ) != NULL );
+			}while(icmp_echo_data_find(&icmp_globals.echo_data, index) != NULL);
 			// found, break immediately
 			break;
 		}
-	}while( icmp_echo_data_find( & icmp_globals.echo_data, index ) != NULL );
+	}while(icmp_echo_data_find(&icmp_globals.echo_data, index) != NULL);
 	echo_data->identifier = index;
 	echo_data->sequence_number = 0;
-	return icmp_echo_data_add( & icmp_globals.echo_data, index, echo_data );
+	return icmp_echo_data_add(&icmp_globals.echo_data, index, echo_data);
 }
 
Index: uspace/srv/net/tl/icmp/icmp_client.c
===================================================================
--- uspace/srv/net/tl/icmp/icmp_client.c	(revision b5cbff48576a057d15deb2e28751ec635d099719)
+++ uspace/srv/net/tl/icmp/icmp_client.c	(revision 936835e135a18adfccf27258eb51edd1dd5fe962)
@@ -49,26 +49,34 @@
 #include "icmp_header.h"
 
-int	icmp_client_process_packet( packet_t packet, icmp_type_t * type, icmp_code_t * code, icmp_param_t * pointer, icmp_param_t * mtu ){
-	icmp_header_ref	header;
+int icmp_client_process_packet(packet_t packet, icmp_type_t * type, icmp_code_t * code, icmp_param_t * pointer, icmp_param_t * mtu){
+	icmp_header_ref header;
 
-	header = ( icmp_header_ref ) packet_get_data( packet );
-	if(( ! header )
-	|| ( packet_get_data_length( packet ) < sizeof( icmp_header_t ))){
+	header = (icmp_header_ref) packet_get_data(packet);
+	if((! header)
+		|| (packet_get_data_length(packet) < sizeof(icmp_header_t))){
 		return 0;
 	}
-	if( type ) * type = header->type;
-	if( code ) * code = header->code;
-	if( pointer ) * pointer = header->un.param.pointer;
-	if( mtu ) * mtu = header->un.frag.mtu;
+	if(type){
+		*type = header->type;
+	}
+	if(code){
+		*code = header->code;
+	}
+	if(pointer){
+		*pointer = header->un.param.pointer;
+	}
+	if(mtu){
+		*mtu = header->un.frag.mtu;
+	}
 	// remove debug dump
-//	printf( "ICMP error %d (%d) in packet %d\n", header->type, header->code, packet_get_id( packet ));
-	return sizeof( icmp_header_t );
+//	printf("ICMP error %d (%d) in packet %d\n", header->type, header->code, packet_get_id(packet));
+	return sizeof(icmp_header_t);
 }
 
-size_t icmp_client_header_length( packet_t packet ){
-	if( packet_get_data_length( packet ) < sizeof( icmp_header_t )){
+size_t icmp_client_header_length(packet_t packet){
+	if(packet_get_data_length(packet) < sizeof(icmp_header_t)){
 		return 0;
 	}
-	return sizeof( icmp_header_t );
+	return sizeof(icmp_header_t);
 }
 
